Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl	(revision 34921)
@@ -6,5 +6,5 @@
 # Notes:        Also contains some less used ExifTool functions
 #
-# URL:          http://owl.phy.queensu.ca/~phil/exiftool/
+# URL:          https://exiftool.org/
 #
 # Revisions:    12/16/2004 - P. Harvey Created
@@ -20,5 +20,6 @@
 sub AssembleRational($$@);
 sub LastInList($);
-sub CreateDirectory($);
+sub CreateDirectory($$);
+sub NextFreeTagKey($$);
 sub RemoveNewValueHash($$$);
 sub RemoveNewValuesForGroup($$);
@@ -28,4 +29,5 @@
 
 my $loadedAllTables;    # flag indicating we loaded all tables
+my $advFmtSelf;         # ExifTool object during evaluation of advanced formatting expr
 
 # the following is a road map of where we write each directory
@@ -47,4 +49,5 @@
     CanonVRD     => 'MakerNotes', # (so VRDOffset will get updated)
     NikonCapture => 'MakerNotes', # (to allow delete by group)
+    PhaseOne     => 'MakerNotes', # (for editing PhaseOne SensorCalibration tags)
 );
 my %exifMap = (
@@ -69,4 +72,5 @@
     ICC_Profile  => 'APP2',
     FlashPix     => 'APP2',
+    MPF          => 'APP2',
     Meta         => 'APP3',
     MetaIFD      => 'Meta',
@@ -74,4 +78,5 @@
     Ducky        => 'APP12',
     Photoshop    => 'APP13',
+    Adobe        => 'APP14',
     IPTC         => 'Photoshop',
     MakerNotes   => ['ExifIFD', 'CIFF'], # (first parent is the default)
@@ -82,4 +87,5 @@
 my %dirMap = (
     JPEG => \%jpegMap,
+    EXV  => \%jpegMap,
     TIFF => \%tiffMap,
     ORF  => \%tiffMap,
@@ -88,4 +94,39 @@
 );
 
+# module names and write functions for each writable file type
+# (defaults to "$type" and "Process$type" if not defined)
+# - types that are handled specially will not appear in this list
+my %writableType = (
+    CRW => [ 'CanonRaw',    'WriteCRW' ],
+    DR4 =>   'CanonVRD',
+    EPS => [ 'PostScript',  'WritePS'  ],
+    FLIF=> [ undef,         'WriteFLIF'],
+    GIF =>   undef,
+    ICC => [ 'ICC_Profile', 'WriteICC' ],
+    IND =>   'InDesign',
+    JP2 =>   'Jpeg2000',
+    MIE =>   undef,
+    MOV => [ 'QuickTime',   'WriteMOV' ],
+    MRW =>   'MinoltaRaw',
+    PDF => [ undef,         'WritePDF' ],
+    PNG =>   undef,
+    PPM =>   undef,
+    PS  => [ 'PostScript',  'WritePS'  ],
+    PSD =>   'Photoshop',
+    RAF => [ 'FujiFilm',    'WriteRAF' ],
+    VRD =>   'CanonVRD',
+    X3F =>   'SigmaRaw',
+    XMP => [ undef,         'WriteXMP' ],
+);
+
+# RAW file types
+my %rawType = (
+   '3FR'=> 1,  CR3 => 1,  IIQ => 1,  NEF => 1,  RW2 => 1,
+    ARQ => 1,  CRW => 1,  K25 => 1,  NRW => 1,  RWL => 1,
+    ARW => 1,  DCR => 1,  KDC => 1,  ORF => 1,  SR2 => 1,
+    ARW => 1,  ERF => 1,  MEF => 1,  PEF => 1,  SRF => 1,
+    CR2 => 1,  FFF => 1,  MOS => 1,  RAW => 1,  SRW => 1,
+);
+
 # groups we are allowed to delete
 # Notes:
@@ -93,9 +134,32 @@
 # 2) any dependencies must be added to %excludeGroups
 my @delGroups = qw(
-    AFCP CanonVRD CIFF Ducky EXIF ExifIFD File FlashPix FotoStation GlobParamIFD
-    GPS ICC_Profile IFD0 IFD1 InteropIFD IPTC JFIF MakerNotes Meta MetaIFD MIE
-    NikonCapture PDF PDF-update PhotoMechanic Photoshop PNG PrintIM RMETA RSRC
-    SubIFD Trailer XML XML-* XMP XMP-*
+    Adobe AFCP APP0 APP1 APP2 APP3 APP4 APP5 APP6 APP7 APP8 APP9 APP10 APP11
+    APP12 APP13 APP14 APP15 CanonVRD CIFF Ducky EXIF ExifIFD File FlashPix
+    FotoStation GlobParamIFD GPS ICC_Profile IFD0 IFD1 Insta360 InteropIFD IPTC
+    ItemList JFIF Jpeg2000 Keys MakerNotes Meta MetaIFD MIE MPF NikonCapture PDF
+    PDF-update PhotoMechanic Photoshop PNG PNG-pHYs PrintIM QuickTime RMETA RSRC
+    SubIFD Trailer UserData XML XML-* XMP XMP-*
 );
+# family 2 group names that we can delete
+my @delGroup2 = qw(
+    Audio Author Camera Document ExifTool Image Location Other Preview Printing
+    Time Video
+);
+# Extra groups to delete when deleting another group
+my %delMore = (
+    QuickTime => [ qw(ItemList UserData Keys) ],
+    XMP => [ 'XMP-*' ],
+    XML => [ 'XML-*' ],
+);
+
+# family 0 groups where directories should never be deleted
+my %permanentDir = ( QuickTime => 1 );
+
+# lookup for all valid family 2 groups (lower case)
+my %family2groups = map { lc $_ => 1 } @delGroup2, 'Unknown';
+
+# groups we don't delete when deleting all information
+my $protectedGroups = '(IFD1|SubIFD|InteropIFD|GlobParamIFD|PDF-update|Adobe)';
+
 # other group names of new tag values to remove when deleting an entire group
 my %removeGroups = (
@@ -125,13 +189,21 @@
     PhotoMechanic=> [ 'Trailer' ],
     MIE          => [ 'Trailer' ],
+    QuickTime    => [ qw(ItemList UserData Keys) ],
+);
+# translate (lower case) wanted group when writing for tags where group name may change
+my %translateWantGroup = (
+    ciff  => 'canonraw',
 );
 # group names to translate for writing
 my %translateWriteGroup = (
-    EXIF => 'ExifIFD',
-    Meta => 'MetaIFD',
-    File => 'Comment',
-    MIE  => 'MIE',
+    EXIF  => 'ExifIFD',
+    Meta  => 'MetaIFD',
+    File  => 'Comment',
+    # any entry in this table causes the write group to be set from the
+    # tag information instead of whatever the user specified...
+    MIE   => 'MIE',
+    APP14 => 'APP14',
 );
-# names of valid EXIF and Meta directories:
+# names of valid EXIF and Meta directories (lower case keys):
 my %exifDirs = (
     gps          => 'GPS',
@@ -140,8 +212,19 @@
     globparamifd => 'GlobParamIFD',
     interopifd   => 'InteropIFD',
-    makernotes   => 'MakerNotes',
     previewifd   => 'PreviewIFD', # (in MakerNotes)
     metaifd      => 'MetaIFD', # Kodak APP3 Meta
+    makernotes   => 'MakerNotes',
 );
+# valid family 0 groups when WriteGroup is set to "All"
+my %allFam0 = (
+    exif         => 1,
+    makernotes   => 1,
+);
+
+my @writableMacOSTags = qw(
+    FileCreateDate MDItemFinderComment MDItemFSCreationDate MDItemFSLabel MDItemUserTags
+    XAttrQuarantine
+);
+
 # min/max values for integer formats
 my %intRange = (
@@ -153,7 +236,9 @@
     'int32u' => [0, 0xffffffff],
     'int32s' => [-0x80000000, 0x7fffffff],
+    'int64u' => [0, 18446744073709551615],
+    'int64s' => [-9223372036854775808, 9223372036854775807],
 );
 # lookup for file types with block-writable EXIF
-my %blockExifTypes = ( JPEG=>1, PNG=>1, JP2=>1, MIE=>1, EXIF=>1 );
+my %blockExifTypes = map { $_ => 1 } qw(JPEG PNG JP2 MIE EXIF FLIF MOV MP4);
 
 my $maxSegmentLen = 0xfffd;     # maximum length of data in a JPEG segment
@@ -164,5 +249,5 @@
 
 # printConv hash keys to ignore when doing reverse lookup
-my %ignorePrintConv = ( OTHER => 1, BITMASK => 1, Notes => 1 );
+my %ignorePrintConv = map { $_ => 1 } qw(OTHER BITMASK Notes);
 
 #------------------------------------------------------------------------------
@@ -175,5 +260,6 @@
 #           Type => PrintConv, ValueConv or Raw - specifies value type
 #           AddValue => true to add to list of existing values instead of overwriting
-#           DelValue => true to delete this existing value value from a list
+#           DelValue => true to delete this existing value value from a list, or
+#                       or doing a conditional delete, or to shift a time value
 #           Group => family 0 or 1 group name (case insensitive)
 #           Replace => 0, 1 or 2 - overwrite previous new values (2=reset)
@@ -182,23 +268,35 @@
 #           EditGroup => true to only edit existing groups (don't create new group)
 #           Shift => undef, 0, +1 or -1 - shift value if possible
+#           NoFlat => treat flattened tags as 'unsafe'
 #           NoShortcut => true to prevent looking up shortcut tags
+#           ProtectSaved => protect existing new values with a save count greater than this
+#           IgnorePermanent => ignore attempts to delete a permanent tag
 #           CreateGroups => [internal use] createGroups hash ref from related tags
 #           ListOnly => [internal use] set only list or non-list tags
 #           SetTags => [internal use] hash ref to return tagInfo refs of set tags
+#           Sanitized => [internal use] set to avoid double-sanitizing the value
 # Returns: number of tags set (plus error string in list context)
 # Notes: For tag lists (like Keywords), call repeatedly with the same tag name for
 #        each value in the list.  Internally, the new information is stored in
-#        the following members of the $self->{NEW_VALUE}{$tagInfo} hash:
+#        the following members of the $$self{NEW_VALUE}{$tagInfo} hash:
 #           TagInfo - tag info ref
-#           DelValue - list ref for values to delete
-#           Value - list ref for values to add
-#           IsCreating - must be set for the tag to be added, otherwise just
-#                        changed if it already exists.  Set to 2 to not create group
+#           DelValue - list ref for raw values to delete
+#           Value - list ref for raw values to add (not defined if deleting the tag)
+#           IsCreating - must be set for the tag to be added for the standard file types,
+#                        otherwise just changed if it already exists.  This may be
+#                        overridden for file types with a PREFERRED metadata type.
+#                        Set to 2 to create individual tags but not new groups
+#           EditOnly - flag set if tag should never be created (regardless of file type).
+#                      If this is set, then IsCreating must be false
+#           CreateOnly - flag set if creating only (never edit existing tag)
 #           CreateGroups - hash of all family 0 group names where tag may be created
 #           WriteGroup - group name where information is being written (correct case)
 #           WantGroup - group name as specified in call to function (case insensitive)
 #           Next - pointer to next new value hash (if more than one)
-#           Self - ExifTool object reference
+#           NoReplace - set if value was created with Replace=0
+#           AddBefore - number of list items added by a subsequent Replace=0 call
+#           IsNVH - Flag indicating this is a new value hash
 #           Shift - shift value
+#           Save - counter used by SaveNewValues()/RestoreNewValues()
 #           MAKER_NOTE_FIXUP - pointer to fixup if necessary for a maker note value
 sub SetNewValue($;$$%)
@@ -206,17 +304,17 @@
     local $_;
     my ($self, $tag, $value, %options) = @_;
-    my ($err, $tagInfo);
-    my $verbose = $self->{OPTIONS}{Verbose};
-    my $out = $self->{OPTIONS}{TextOut};
+    my ($err, $tagInfo, $family);
+    my $verbose = $$self{OPTIONS}{Verbose};
+    my $out = $$self{OPTIONS}{TextOut};
     my $protected = $options{Protected} || 0;
     my $listOnly = $options{ListOnly};
     my $setTags = $options{SetTags};
+    my $noFlat = $options{NoFlat};
     my $numSet = 0;
 
     unless (defined $tag) {
-        # remove any existing set values
-        delete $self->{NEW_VALUE};
-        $self->{DEL_GROUP} = { };
-        $verbose > 1 and print $out "Cleared new values\n";
+        delete $$self{NEW_VALUE};
+        $$self{SAVE_COUNT} = 0;
+        $$self{DEL_GROUP} = { };
         return 1;
     }
@@ -224,17 +322,26 @@
     if (ref $value) {
         if (ref $value eq 'ARRAY') {
-            # (since value is an ARRAY, it will have more than one entry)
-            # set all list-type tags first
-            my $replace = $options{Replace};
-            foreach (@$value) {
-                my ($n, $e) = SetNewValue($self, $tag, $_, %options, ListOnly => 1);
-                $err = $e if $e;
-                $numSet += $n;
-                delete $options{Replace}; # don't replace earlier values in list
-            }
-            # and now set only non-list tags
-            $value = join $self->{OPTIONS}{ListSep}, @$value;
-            $options{Replace} = $replace;
-            $listOnly = $options{ListOnly} = 0;
+            # value is an ARRAY so it may have more than one entry
+            # - set values both separately and as a combined string if there are more than one
+            if (@$value > 1) {
+                # set all list-type tags first
+                my $replace = $options{Replace};
+                my $noJoin;
+                foreach (@$value) {
+                    $noJoin = 1 if ref $_;
+                    my ($n, $e) = SetNewValue($self, $tag, $_, %options, ListOnly => 1);
+                    $err = $e if $e;
+                    $numSet += $n;
+                    delete $options{Replace}; # don't replace earlier values in list
+                }
+                return $numSet if $noJoin;  # don't join if list contains objects
+                # and now set only non-list tags
+                $value = join $$self{OPTIONS}{ListSep}, @$value;
+                $options{Replace} = $replace;
+                $listOnly = $options{ListOnly} = 0;
+            } else {
+                $value = $$value[0];
+                $value = $$value if ref $value eq 'SCALAR'; # (handle single scalar ref in a list)
+            }
         } elsif (ref $value eq 'SCALAR') {
             $value = $$value;
@@ -243,159 +350,234 @@
     # un-escape as necessary and make sure the Perl UTF-8 flag is OFF for the value
     # if perl is 5.6 or greater (otherwise our byte manipulations get corrupted!!)
-    $self->Sanitize(\$value) if defined $value and not ref $value;
+    $self->Sanitize(\$value) if defined $value and not ref $value and not $options{Sanitized};
 
     # set group name in options if specified
-    if ($tag =~ /(.*):(.+)/) {
-        $options{Group} = $1 if $1 ne '*' and lc($1) ne 'all';
-        $tag = $2;
-    }
+    ($options{Group}, $tag) = ($1, $2) if $tag =~ /(.*):(.+)/;
+
     # allow trailing '#' for ValueConv value
     $options{Type} = 'ValueConv' if $tag =~ s/#$//;
-    # ignore leading family number if 0 or 1 specified
-    if ($options{Group} and $options{Group} =~ /^(\d+)(.*)/ and $1 < 2) {
-        $options{Group} = $2;
+    my $convType = $options{Type} || ($$self{OPTIONS}{PrintConv} ? 'PrintConv' : 'ValueConv');
+
+    # filter value if necessary
+    $self->Filter($$self{OPTIONS}{FilterW}, \$value) or return 0 if $convType eq 'PrintConv';
+
+    my (@wantGroup, $family2);
+    my $wantGroup = $options{Group};
+    if ($wantGroup) {
+        foreach (split /:/, $wantGroup) {
+            next unless length($_) and /^(\d+)?(.*)/; # separate family number and group name
+            my ($f, $g) = ($1, $2);
+            my $lcg = lc $g;
+            # save group/family unless '*' or 'all'
+            push @wantGroup, [ $f, $lcg ] unless $lcg eq '*' or $lcg eq 'all';
+            if ($g =~ s/^ID-//i) {          # family 7 is a tag ID
+                return 0 if defined $f and $f ne 7;
+                $wantGroup[-1] = [ 7, $g ]; # group name with 'ID-' removed and case preserved
+            } elsif (defined $f) {
+                $f > 2 and return 0;        # only allow family 0, 1 or 2
+                $family2 = 1 if $f == 2;    # set flag indicating family 2 was used
+            } else {
+                $family2 = 1 if $family2groups{$lcg};
+            }
+        }
+        undef $wantGroup unless @wantGroup;
+    }
+
+    $tag =~ s/ .*//;    # convert from tag key to tag name if necessary
+    $tag = '*' if lc($tag) eq 'all';    # use '*' instead of 'all'
+#
+# handle group delete
+#
+    while ($tag eq '*' and not defined $value and not $family2 and @wantGroup < 2) {
+        # set groups to delete
+        my (@del, $grp);
+        my $remove = ($options{Replace} and $options{Replace} > 1);
+        if ($wantGroup) {
+            @del = grep /^$wantGroup$/i, @delGroups unless $wantGroup =~ /^XM[LP]-\*$/i;
+            # remove associated groups when excluding from mass delete
+            if (@del and $remove) {
+                # remove associated groups in other family
+                push @del, @{$excludeGroups{$del[0]}} if $excludeGroups{$del[0]};
+                # remove upstream groups according to JPEG map
+                my $dirName = $del[0];
+                my @dirNames;
+                for (;;) {
+                    my $parent = $jpegMap{$dirName};
+                    if (ref $parent) {
+                        push @dirNames, @$parent;
+                        $parent = pop @dirNames;
+                    }
+                    $dirName = $parent || shift @dirNames or last;
+                    push @del, $dirName;    # exclude this too
+                }
+            }
+            # allow MIE groups to be deleted by number,
+            # and allow any XMP family 1 group to be deleted
+            push @del, uc($wantGroup) if $wantGroup =~ /^(MIE\d+|XM[LP]-[-\w]*\w)$/i;
+        } else {
+            # push all groups plus '*', except the protected groups
+            push @del, (grep !/^$protectedGroups$/, @delGroups), '*';
+        }
+        if (@del) {
+            ++$numSet;
+            my @donegrps;
+            my $delGroup = $$self{DEL_GROUP};
+            foreach $grp (@del) {
+                if ($remove) {
+                    my $didExcl;
+                    if ($grp =~ /^(XM[LP])(-.*)?$/) {
+                        my $x = $1;
+                        if ($grp eq $x) {
+                            # exclude all related family 1 groups too
+                            foreach (keys %$delGroup) {
+                                next unless /^(-?)$x-/;
+                                push @donegrps, $_ unless $1;
+                                delete $$delGroup{$_};
+                            }
+                        } elsif ($$delGroup{"$x-*"} and not $$delGroup{"-$grp"}) {
+                            # must also exclude XMP or XML to prevent bulk delete
+                            if ($$delGroup{$x}) {
+                                push @donegrps, $x;
+                                delete $$delGroup{$x};
+                            }
+                            # flag XMP/XML family 1 group for exclusion with leading '-'
+                            $$delGroup{"-$grp"} = 1;
+                            $didExcl = 1;
+                        }
+                    }
+                    if (exists $$delGroup{$grp}) {
+                        delete $$delGroup{$grp};
+                    } else {
+                        next unless $didExcl;
+                    }
+                } else {
+                    $$delGroup{$grp} = 1;
+                    # add extra groups to delete if necessary
+                    if ($delMore{$grp}) {
+                        $$delGroup{$_} = 1, push @donegrps, $_ foreach @{$delMore{$grp}};
+                    }
+                    # remove all of this group from previous new values
+                    $self->RemoveNewValuesForGroup($grp);
+                }
+                push @donegrps, $grp;
+            }
+            if ($verbose > 1 and @donegrps) {
+                @donegrps = sort @donegrps;
+                my $msg = $remove ? 'Excluding from deletion' : 'Deleting tags in';
+                print $out "  $msg: @donegrps\n";
+            }
+        } elsif (grep /^$wantGroup$/i, @delGroup2) {
+            last;   # allow tags to be deleted by group2 name
+        } else {
+            $err = "Not a deletable group: $wantGroup";
+        }
+        # all done
+        return ($numSet, $err) if wantarray;
+        $err and warn "$err\n";
+        return $numSet;
+    }
+
+    # initialize write/create flags
+    my $createOnly;
+    my $editOnly = $options{EditOnly};
+    my $editGroup = $options{EditGroup};
+    my $writeMode = $$self{OPTIONS}{WriteMode};
+    if ($writeMode ne 'wcg') {
+        $createOnly = 1 if $writeMode !~ /w/i;  # don't write existing tags
+        if ($writeMode !~ /c/i) {
+            return 0 if $createOnly;    # nothing to do unless writing existing tags
+            $editOnly = 1;              # don't create new tags
+        } elsif ($writeMode !~ /g/i) {
+            $editGroup = 1;             # don't create new groups
+        }
+    }
+    my ($ifdName, $mieGroup, $movGroup, $fg);
+    # set family 1 group names
+    foreach $fg (@wantGroup) {
+        next if defined $$fg[0] and $$fg[0] != 1;
+        $_ = $$fg[1];
+        # set $ifdName if this group is a valid IFD or SubIFD name
+        my $grpName;
+        if (/^IFD(\d+)$/i) {
+            $grpName = $ifdName = "IFD$1";
+        } elsif (/^SubIFD(\d+)$/i) {
+            $grpName = $ifdName = "SubIFD$1";
+        } elsif (/^Version(\d+)$/i) {
+            $grpName = $ifdName = "Version$1"; # Sony IDC VersionIFD
+        } elsif ($exifDirs{$_}) {
+            $grpName = $exifDirs{$_};
+            $ifdName = $grpName unless $ifdName and $allFam0{$_};
+        } elsif ($allFam0{$_}) {
+            $grpName = $allFam0{$_};
+        } elsif (/^Track(\d+)$/i) {
+            $grpName = $movGroup = "Track$1";  # QuickTime track
+        } elsif (/^MIE(\d*-?)(\w+)$/i) {
+            $grpName = $mieGroup = "MIE$1" . ucfirst(lc($2));
+        } elsif (not $ifdName and /^XMP\b/i) {
+            # must load XMP table to set group1 names
+            my $table = GetTagTable('Image::ExifTool::XMP::Main');
+            my $writeProc = $$table{WRITE_PROC};
+            if ($writeProc) {
+                no strict 'refs';
+                &$writeProc();
+            }
+        }
+        # fix case for known groups
+        $wantGroup =~ s/$grpName/$grpName/i if $grpName and $grpName ne $_;
     }
 #
 # get list of tags we want to set
 #
-    my $wantGroup = $options{Group};
-    $tag =~ s/ .*//;    # convert from tag key to tag name if necessary
+    my $origTag = $tag;
     my @matchingTags = FindTagInfo($tag);
     until (@matchingTags) {
-        if ($tag eq '*' or lc($tag) eq 'all') {
-            # set groups to delete
-            if (defined $value) {
-                $err = "Can't set value for all tags";
-            } else {
-                my (@del, $grp);
-                my $remove = ($options{Replace} and $options{Replace} > 1);
-                if ($wantGroup) {
-                    @del = grep /^$wantGroup$/i, @delGroups unless $wantGroup =~ /^XM[LP]-\*$/i;
-                    # remove associated groups when excluding from mass delete
-                    if (@del and $remove) {
-                        # remove associated groups in other family
-                        push @del, @{$excludeGroups{$del[0]}} if $excludeGroups{$del[0]};
-                        # remove upstream groups according to JPEG map
-                        my $dirName = $del[0];
-                        my @dirNames;
-                        for (;;) {
-                            my $parent = $jpegMap{$dirName};
-                            if (ref $parent) {
-                                push @dirNames, @$parent;
-                                $parent = pop @dirNames;
-                            }
-                            $dirName = $parent || shift @dirNames or last;
-                            push @del, $dirName;    # exclude this too
-                        }
-                    }
-                    # allow MIE groups to be deleted by number,
-                    # and allow any XMP family 1 group to be deleted
-                    push @del, uc($wantGroup) if $wantGroup =~ /^(MIE\d+|XM[LP]-[-\w]+)$/i;
+        my $langCode;
+        # allow language suffix of form "-en_CA" or "-<rfc3066>" on tag name
+        if ($tag =~ /^([?*\w]+)-([a-z]{2})(_[a-z]{2})$/i or # MIE
+            $tag =~ /^([?*\w]+)-([a-z]{2,3}|[xi])(-[a-z\d]{2,8}(-[a-z\d]{1,8})*)?$/i) # XMP/PNG/QuickTime
+        {
+            $tag = $1;
+            # normalize case of language codes
+            $langCode = lc($2);
+            $langCode .= (length($3) == 3 ? uc($3) : lc($3)) if $3;
+            my @newMatches = FindTagInfo($tag);
+            foreach $tagInfo (@newMatches) {
+                # only allow language codes in tables which support them
+                next unless $$tagInfo{Table};
+                my $langInfoProc = $$tagInfo{Table}{LANG_INFO} or next;
+                my $langInfo = &$langInfoProc($tagInfo, $langCode);
+                push @matchingTags, $langInfo if $langInfo;
+            }
+            last if @matchingTags;
+        } elsif (not $options{NoShortcut}) {
+            # look for a shortcut or alias
+            require Image::ExifTool::Shortcuts;
+            my ($match) = grep /^\Q$tag\E$/i, keys %Image::ExifTool::Shortcuts::Main;
+            undef $err;
+            if ($match) {
+                $options{NoShortcut} = $options{Sanitized} = 1;
+                foreach $tag (@{$Image::ExifTool::Shortcuts::Main{$match}}) {
+                    my ($n, $e) = $self->SetNewValue($tag, $value, %options);
+                    $numSet += $n;
+                    $e and $err = $e;
+                }
+                undef $err if $numSet;  # no error if any set successfully
+                return ($numSet, $err) if wantarray;
+                $err and warn "$err\n";
+                return $numSet;
+            }
+        }
+        unless ($listOnly) {
+            if (not TagExists($tag)) {
+                if ($tag =~ /^[-\w*?]+$/) {
+                    my $pre = $wantGroup ? $wantGroup . ':' : '';
+                    $err = "Tag '$pre${origTag}' is not defined";
+                    $err .= ' or has a bad language code' if $origTag =~ /-/;
                 } else {
-                    # push all groups plus '*', except IFD1 and a few others
-                    push @del, (grep !/^(IFD1|SubIFD|InteropIFD|GlobParamIFD|PDF-update)$/, @delGroups), '*';
-                }
-                if (@del) {
-                    ++$numSet;
-                    my @donegrps;
-                    my $delGroup = $self->{DEL_GROUP};
-                    foreach $grp (@del) {
-                        if ($remove) {
-                            my $didExcl;
-                            if ($grp =~ /^(XM[LP])(-.*)?$/) {
-                                my $x = $1;
-                                if ($grp eq $x) {
-                                    # exclude all related family 1 groups too
-                                    foreach (keys %$delGroup) {
-                                        next unless /^-?$x-/;
-                                        push @donegrps, $_ if /^$x/;
-                                        delete $$delGroup{$_};
-                                    }
-                                } elsif ($$delGroup{"$x-*"} and not $$delGroup{"-$grp"}) {
-                                    # must also exclude XMP or XML to prevent bulk delete
-                                    if ($$delGroup{$x}) {
-                                        push @donegrps, $x;
-                                        delete $$delGroup{$x};
-                                    }
-                                    # flag XMP/XML family 1 group for exclusion with leading '-'
-                                    $$delGroup{"-$grp"} = 1;
-                                    $didExcl = 1;
-                                }
-                            }
-                            if (exists $$delGroup{$grp}) {
-                                delete $$delGroup{$grp};
-                            } else {
-                                next unless $didExcl;
-                            }
-                        } else {
-                            $$delGroup{$grp} = 1;
-                            # add flag for XMP/XML family 1 groups if deleting all XMP
-                            if ($grp =~ /^XM[LP]$/) {
-                                $$delGroup{"$grp-*"} = 1;
-                                push @donegrps, "$grp-*";
-                            }
-                            # remove all of this group from previous new values
-                            $self->RemoveNewValuesForGroup($grp);
-                        }
-                        push @donegrps, $grp;
-                    }
-                    if ($verbose > 1 and @donegrps) {
-                        @donegrps = sort @donegrps;
-                        my $msg = $remove ? 'Excluding from deletion' : 'Deleting tags in';
-                        print $out "  $msg: @donegrps\n";
-                    }
-                } else {
-                    $err = "Not a deletable group: $wantGroup";
-                }
-            }
-        } else {
-            my $origTag = $tag;
-            my $langCode;
-            # allow language suffix of form "-en_CA" or "-<rfc3066>" on tag name
-            if ($tag =~ /^(\w+)-([a-z]{2})(_[a-z]{2})$/i or # MIE
-                $tag =~ /^(\w+)-([a-z]{2,3}|[xi])(-[a-z\d]{2,8}(-[a-z\d]{1,8})*)?$/i) # XMP/PNG
-            {
-                $tag = $1;
-                # normalize case of language codes
-                $langCode = lc($2);
-                $langCode .= (length($3) == 3 ? uc($3) : lc($3)) if $3;
-                my @newMatches = FindTagInfo($tag);
-                foreach $tagInfo (@newMatches) {
-                    # only allow language codes in tables which support them
-                    next unless $$tagInfo{Table};
-                    my $langInfoProc = $tagInfo->{Table}{LANG_INFO} or next;
-                    my $langInfo = &$langInfoProc($tagInfo, $langCode);
-                    push @matchingTags, $langInfo if $langInfo;
-                }
-                last if @matchingTags;
-            } else {
-                # look for a shortcut or alias
-                require Image::ExifTool::Shortcuts;
-                my ($match) = grep /^\Q$tag\E$/i, keys %Image::ExifTool::Shortcuts::Main;
-                undef $err;
-                if ($match and not $options{NoShortcut}) {
-                    if (@{$Image::ExifTool::Shortcuts::Main{$match}} == 1) {
-                        $tag = $Image::ExifTool::Shortcuts::Main{$match}[0];
-                        @matchingTags = FindTagInfo($tag);
-                        last if @matchingTags;
-                    } else {
-                        $options{NoShortcut} = 1;
-                        foreach $tag (@{$Image::ExifTool::Shortcuts::Main{$match}}) {
-                            my ($n, $e) = $self->SetNewValue($tag, $value, %options);
-                            $numSet += $n;
-                            $e and $err = $e;
-                        }
-                        undef $err if $numSet;  # no error if any set successfully
-                        return ($numSet, $err) if wantarray;
-                        $err and warn "$err\n";
-                        return $numSet;
-                    }
-                }
-            }
-            if (not TagExists($tag)) {
-                $err = "Tag '$origTag' does not exist";
-                $err .= ' or has a bad language code' if $origTag =~ /-/;
+                    $err = "Invalid tag name '${tag}'";
+                    $err .= " (remove the leading '\$')" if $tag =~ /^\$/;
+                }
             } elsif ($langCode) {
-                $err = "Tag '$tag' does not support alternate languages";
+                $err = "Tag '${tag}' does not support alternate languages";
             } elsif ($wantGroup) {
                 $err = "Sorry, $wantGroup:$origTag doesn't exist or isn't writable";
